#define M 13

typedef int Marray_t[M][M];

/* $begin transpose-c */
void transpose(Marray_t A) {
    int i, j;
    for (i = 0; i < M; i++)
	for (j = 0; j < i; j++) {
	    int t = A[i][j];
	    A[i][j] = A[j][i];
	    A[j][i] = t;
	}
}
/* $end transpose-c */

/* $begin transpose-opt-c */
void transpose_opt(Marray_t A) {
    int i, j;
    for (i = 0; i < M; i++) {
	int *Arow = &A[i][0];
	int *Acol = &A[0][i];
	for (j = 0; j < i; j++) {
	    int t1 = *Acol;
	    int t2 = Arow[j];
	    *Acol = t2;
	    Arow[j] = t1;
	    Acol += M;
	}
    }
}
/* $end transpose-opt-c */
