#include <limits.h>
#include <stdio.h>

/* Code for tree traversals */

/* $begin tree-decl-c */
typedef struct ELE *tree_ptr;

struct ELE {
    long val;
    tree_ptr left;
    tree_ptr right;
};
/* $end tree-decl-c */

/* $begin tree-trace-proto-c */
long trace(tree_ptr tp);
/* $end tree-trace-proto-c */

/* $begin tree-trace-ans-c */
/* Find the value in the leaf reached by following rightmost path */
long trace(tree_ptr tp) {
    long val = 0;
    while (tp) {
	val = tp->val;
	tp = tp->right;
    }
    return val;
}
/* $end tree-trace-ans-c */

/* $begin tree-traverse-proto-c */
long traverse(tree_ptr tp);
/* $end tree-traverse-proto-c */

/* $begin tree-traverse-ans-c */
/* This looks for the max value in a tree */
long traverse(tree_ptr tp) {
    if (!tp)
	return LONG_MIN;
    else {
	long val = tp->val;
	long lval, rval;
	lval = traverse(tp->left);
	if (lval > val)
	    val = lval;
	rval = traverse(tp->right);
	if (rval > val)
	    val = rval;
	return val;
    }
}
/* $end tree-traverse-ans-c */

/* This finds the sum in the tree */
long traverse1(tree_ptr tp) {
    long val = tp->val;
    if (tp->left)
	val += traverse1(tp->left);
    if (tp->right)
	val += traverse1(tp->right);
    return val;
}


/* Find the value in the leaf reached by following specified path */
long trace1(tree_ptr tp, long unsigned path) {
    tree_ptr lastp;
    do {
	lastp = tp;
	tp = path & 0x1 ? tp->right : tp->left;
	path >>= 1;
    } while (tp);
    return lastp->val;
}

/* Find the value in the leaf reached by following rightmost path */
long trace2(tree_ptr tp) {
    tree_ptr last = NULL;
    while (tp) {
	last = tp;
	tp = tp->right;
    }
    return last ? last->val : 0;
}

/* Count number of nodes encountered while following specified path */
int trace3(tree_ptr tp, long unsigned path) {
    int val = 0;
    while (tp) {
	tp = path & 0x1 ? tp->right : tp->left;
	path >>= 1;
	val++;
    }
    return val;
}

int trace4(tree_ptr tp, long unsigned path) {
    if (!tp)
	return 0;
    else {
	tree_ptr next = path & 0x1 ? tp->right : tp->left;
	return 1 + trace4(next, path >> 1);
    }
}
  
